#pragma once

#include "GameObject.h"
#include "Spieler.h"

enum GeschossTyp
{
    GESCHOSS_PFEIL,
    GESCHOSS_KUGEL,
    GESCHOSS_DRACHENAUGE,
    GESCHOSS_FEUERBALL
};

class Geschoss : public GameObject
{
private:
    float speed;
    Richtung richtung;
    Spieler *besitzer;
    GeschossTyp typ;
    int tunnelBenutzt;
    int umgelenkt;
    int geschosseGetroffen;

public:
    Geschoss( float speed, GeschossTyp typ, Richtung r, int x, int y, Spieler *besitzer );
    ~Geschoss();
    void invertDirection();
    void setRichtung( Richtung r );
    void tick( double zeit );
    GeschossTyp getTyp() const;
    Spieler *zBesitzer() const;
    Spieler *getBesitzer() const;
};

// size: 150x150
class FeuerballTreffer : public GameObject
{
private:
    Spieler *besitzer;
    float timeLeft;

public:
    FeuerballTreffer( int x, int y, Spieler *besitzer, int maxZeit );
    ~FeuerballTreffer();
    void tick( double zeit );
};